package hdl

import (
	"applet/app/admin/enum"
	"applet/app/admin/md"
	"applet/app/admin/svc"
	"applet/app/db"
	"applet/app/e"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
)

func MenuList(c *gin.Context) {
	admin := svc.GetUser(c)
	qrcodeWithBatchRecordsDb := db.PermissionGroupDb{}
	qrcodeWithBatchRecordsDb.Set()
	groupList, err := qrcodeWithBatchRecordsDb.FindPermissionGroup()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	//1、查询出当前用户所有角色
	adminRoleDb := db.AdminRoleDb{}
	adminRoleDb.Set()
	roles, err := adminRoleDb.FindAdminRole(admin.AdmId)
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	roleDb := db.RoleDb{}
	roleDb.Set(0)
	var adminHasPermissionGroupIds []string
	for _, v := range *roles {
		list, _, err := roleDb.FindPermissionGroupByRole(v.RoleId)
		if err != nil {
			e.OutErr(c, e.ERR_DB_ORM, err.Error())
			return
		}
		for _, v1 := range list {
			adminHasPermissionGroupIds = append(adminHasPermissionGroupIds, utils.IntToStr(v1.PermissionGroup.Id))
		}
	}

	var tempRespMap = map[string]*md.PermissionGroupListResp{}
	var tempRespMapKeys []string
	for _, v := range *groupList {
		isCheck := false
		if utils.InArr(utils.IntToStr(v.Id), adminHasPermissionGroupIds) {
			isCheck = true
		}
		tempRespMap[utils.IntToStr(v.Id)] = &md.PermissionGroupListResp{
			Id:       v.Id,
			Name:     v.Name,
			State:    v.State,
			ParentId: v.ParentId,
			CreateAt: v.CreateAt.Format("2006-01-02 15:04:05"),
			UpdateAt: v.UpdateAt.Format("2006-01-02 15:04:05"),
			IsCheck:  isCheck,
		}
		tempRespMapKeys = append(tempRespMapKeys, utils.IntToStr(v.Id))
	}
	for _, v := range tempRespMap {
		if v.ParentId != 0 {
			tempRespMap[utils.IntToStr(v.ParentId)].SubPermissionGroupList = append(tempRespMap[utils.IntToStr(v.ParentId)].SubPermissionGroupList, *v)
		}
	}

	var resp []md.PermissionGroupListResp
	for _, v := range tempRespMapKeys {
		resp = append(resp, *tempRespMap[v])
	}

	e.OutSuc(c, map[string]interface{}{
		"list": resp,
		"state": []map[string]interface{}{
			{
				"name":  enum.PermissionGroupState(enum.PermissionGroupStateForNormal).String(),
				"value": enum.PermissionGroupStateForNormal,
			},
			{
				"name":  enum.PermissionGroupState(enum.PermissionGroupStateForDiscard).String(),
				"value": enum.PermissionGroupStateForDiscard,
			},
		},
	}, nil)
	return
}
